#! /usr/bin/python

#     file     : projects/PaminaIII/bin/Transims2Pamina
#     project  : Pamina III simulation suite
#     author   : Marcus Rickert
#     RCS      : $Id: Transims2Pamina.py,v 1.1 2005/03/26 06:12:29 mr Exp $
#     purpose  : converts network files from TRANSIMS to PAMINA format
#
#     Copyright (C) 2005 :  Marcus Rickert

# TODO:
#

import string

from t_AppException import *

COL_LINK_ID = 0
COL_NODE_ID_A = 1
COL_NODE_ID_B = 2
COL_LANES_TO_A = 3
COL_LANES_TO_B = 4
COL_LENGTH = 5
COL_SPEED_LIMIT_TO_A = 8
COL_SPEED_LIMIT_TO_B = 9
COL_FREE_SPEED_TO_A = 10
COL_FREE_SPEED_TO_B = 11
COL_LINK_CLASS = 14

COL_NODE_ID = 0
COL_X_COORDINATE = 1
COL_Y_COORDINATE = 2

# -----------------------------------------------------------------------------------

def ConvertNodes():

    l_Line = sys.stdin.readline()
    while (l_Line):

        if l_Line[-1] == '\n':
            l_Line = l_Line[0:-1]
        l_Cols = string.split(l_Line, ',')


        print "%s %s %s" % (l_Cols[COL_NODE_ID], \
                            l_Cols[COL_X_COORDINATE], \
                            l_Cols[COL_Y_COORDINATE])
        
        l_Line = sys.stdin.readline()
    
# -----------------------------------------------------------------------------------

def ConvertLinks():

    l_Line = sys.stdin.readline()
    while (l_Line):

        if l_Line[-1] == '\n':
            l_Line = l_Line[0:-1]
        l_Cols = string.split(l_Line, ',')

        # link from B to A
        # PAMINA link ID = 2 * TRANSIMS link ID
        print "%d %s %s %s %s %s %s %s" % (2 * int(l_Cols[COL_LINK_ID]),
                                           l_Cols[COL_NODE_ID_B], \
                                           l_Cols[COL_NODE_ID_A], \
                                           l_Cols[COL_LANES_TO_A], \
                                           l_Cols[COL_LENGTH], \
                                           l_Cols[COL_LINK_CLASS], \
                                           l_Cols[COL_SPEED_LIMIT_TO_A], \
                                           l_Cols[COL_FREE_SPEED_TO_A])

        # link from A to B
        # PAMINA link ID = 2 * TRANSIMS link ID + 1
        print "%d %s %s %s %s %s %s %s" % (2 * int(l_Cols[COL_LINK_ID]) + 1,
                                           l_Cols[COL_NODE_ID_A], \
                                           l_Cols[COL_NODE_ID_B], \
                                           l_Cols[COL_LANES_TO_B], \
                                           l_Cols[COL_LENGTH], \
                                           l_Cols[COL_LINK_CLASS], \
                                           l_Cols[COL_SPEED_LIMIT_TO_B], \
                                           l_Cols[COL_FREE_SPEED_TO_B])

        l_Line = sys.stdin.readline()

        
# -----------------------------------------------------------------------------------

if __name__ == '__main__':
    try:

        l_CommentLine = sys.stdin.readline();
        l_Comment = l_CommentLine[0:-1]

        if l_Comment == '"Id","Abscissa","Ordinate"':
            ConvertNodes()
            
        elif l_Comment == '"Id","Nodea","Nodeb","Permlanesa","Permlanesb","Length","Capacitya","Capacityb","Speedlmta","Speedlmtb","Freespda","Freespdb","Crawlspda","Crawlspdb","Fclass","Tollab","Tollba"':
            ConvertLinks()
            
        else:
            raise t_AppException(p_Message = ("invalid comment '%s' line in source" % l_Comment))
                
    except IOError:
        printExceptionMessages()
            
    except t_AppException, Exception:
        printExceptionMessages()
