/*      file     : ParSim/TParSimMaster.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TParSimMaster.h,v 1.11 2005/03/25 11:07:34 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TPARSIMMASTER_H
#define TPARSIMMASTER_H

// ***INCLUDES************************************************************************ 

#include <TApplicationMaster.h>
#include <TStatHandler.h>

// ***FORWARDS************************************************************************

class TAggregationInfo;
class TStream;
class TTimeStep;

// ***CLASSES************************************************************************* 

class TParSimMaster : public TApplicationMaster, public TStatHandler
                      

{
public:

    TParSimMaster(TApplicationSlave *theApplicationSlave);
    virtual ~TParSimMaster(void);

    virtual bool
        Run(void);

private:

    bool
    ActivateStatistics(void);

    bool
    Distribute(void);

    virtual TString
    GetClassName(void) const;

    virtual bool
    HandleAggregationResult(TAggregationInfo *AggregationInfo, TTimeStep &TimeStep);

    bool
    HandleMultilaneResult(TAggregationInfo *AggregationInfo, TTimeStep &TimeStep);

    TSamplingDescription  *MultilaneSamplingDescription;
    TAggregationInfo      *MultilaneAggregationInfo;
    long                   MaxTimeSteps;
    long                   GridLockTimeOut;
    long                   SequenceLength;

    bool                   MultilaneStatDump;
    int                    MultilaneStatInterval;
    TStream               *MultilaneStatOutput;
    double                 MinCompletion;
    long                   PreviousVehicleCount;
    long                   PreviousVehicleSpeed;
    TTimeStep              PreviousVehicleTimeStep;

    long                   SumSites;
    long                   SumObjects;
    long                   SumSpeed;
    bool                   PerfStatDump;
    TStream               *PerfStatOutput;
    int                    PerfStatInterval;
    TTimeStep              StartTimeStep;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif


