/*      file     : RouteConverter/TLinkHitStat.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TLinkHitStat.h,v 1.2 2005/03/25 12:28:20 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TLINKHITSTAT_H
#define TLINKHITSTAT_H

/* ***INCLUDES************************************************************************ */

#include <TDLList.h>
#include <TParallelObject.h>
#include <CAConfig.h>

// ***FORWARDS************************************************************************

class TBaseStream;
class TMultilaneGrid;

/* ***CLASSES************************************************************************* */

class TLinkHitStat : public TParallelObject

{
 public:

    TLinkHitStat(TParallelID theParallelID,
                 long theStartTimeStep, long theEndTimeStep, long theBinSize);
    virtual ~TLinkHitStat(void);

    inline void
    Hit(long TimeStep);
    
    bool
    Write(TBaseStream *Stream);

    static TClassInfo *ClassInfo;

 private:

    virtual TString
    GetClassName(void) const;

    virtual void
    Reset(void);

    long  StartTimeStep;
    long  BinSize;
    long  NrOfBins;
    long *Hits;
};

// ***TYPES***************************************************************************

typedef TDLList< TLinkHitStat > TLinkHitStatList;
typedef TDLListEnum< TLinkHitStat > TLinkHitStatEnum;

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TLinkHitStat.i.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
