/*      file     : TrafficData/TAlgoEdge.h
        project  : PAMINA III
        author   : Marcus Rickert
        RCS      : $Id: TAlgoEdge.h,v 1.2 2005/03/25 12:28:51 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TALGOEDGE_H
#define TALGOEDGE_H

// ***INCLUDES************************************************************************ 

#include <TGridStatLookup.h>
#include <TBaseObject.h>

// ***FORWARDS************************************************************************

class TAlgoInfo;

#include <TEdge.forward.h>

// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***CLASSES************************************************************************* 

class TAlgoEdge : public TBaseObject

{
public:

    TAlgoEdge(void);    

    virtual TString
    GetClassName(void) const;

    inline TAlgoInfo *
    GetDestAlgoInfo(void);

    inline TAlgoInfo *
    GetOriginAlgoInfo(void);

    inline TParallelID
    GetParallelID(void) const;

    bool
    Load(TEdge *theEdge, TInfoID LookupClassInfoID = INVALID, 
         TAlgoInfo *theOriginAlgoInfo = 0, TAlgoInfo *theDestAlgoInfo = 0);

    TEdge           *Edge;
    TAlgoInfo       *OriginAlgoInfo;
    TAlgoInfo       *DestAlgoInfo;
    TGridStatLookup *Lookup;
};

// ***EXTERNALS*********************************************************************** 
// ***PROTOTYPES********************************************************************** 
#ifdef __cplusplus
extern "C" {
#endif

    int
        CompareAlgoEdges(TAlgoEdge *Info1, TAlgoEdge *Info2);

#ifdef __cplusplus
}
#endif
// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TAlgoEdge.i.C"
#endif

// ***TEMPLATE METHODS**************************************************************** 
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
