/*      file     : common/File.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: File.C,v 1.8 2005/03/25 11:04:58 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

extern "C"
{
#include "sys/stat.h"
}
#include "unistd.h"

#include "Basic.h"
#include "File.h"

// ***FUNCTIONS*********************************************************************** 

bool
fexist(const char *Filename)

{
    struct stat stat_buffer;

    if (stat(Filename, &stat_buffer) != 0)
        return FALSE;
    return TRUE;
}

// =================================================================================== 

long
fmodified(const char *Filename)

{
    struct stat stat_buffer;

    if (stat(Filename, &stat_buffer) != 0)
        return -1;
    return stat_buffer.st_mtime;
}

// =================================================================================== 

long
fsize(FILE *file)

{
    long Offset;
    long Size;

    Offset = ftell(file);
    fseek(file, 0, SEEK_END);
    Size = ftell(file);
    fseek(file, Offset, SEEK_SET);
    return Size;
}

// =================================================================================== 

long
fsize(int fd)

{
    struct stat stat_buffer;

    fstat(fd, &stat_buffer);
    return (long) stat_buffer.st_size;
}

// =================================================================================== 

long
fsize(const char *Filename)

{
    struct stat stat_buffer;

    stat(Filename, &stat_buffer);
    return (long) stat_buffer.st_size;
}

// =================================================================================== 


