/*      file     : common/TConfigHandler.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TConfigHandler.C,v 1.4 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************ 

#include <stdarg.h>

#include <TConfigHandler.h>
#include <TConfig.h>

// ***METHODS************************************************************************* 

// =================================================================================== 
#define ParentClass
// =================================================================================== 

TConfigHandler::TConfigHandler(void)

{
    Config = 0;
}

// =================================================================================== 

const TConfig *
TConfigHandler::GetConfig(void) const

{
    return Config;
}

// =================================================================================== 

void
TConfigHandler::WriteSignature(void) const

{
    Config->SignatureLine("WriteSignature not overloaded");
}

// =================================================================================== 

void
TConfigHandler::RegisterTokenArray(int &Index, char **Tokens, 
                                   int Count, char **NewTokens)

{
    int i;

    for (i = 0; i < Count; i++)
        Tokens[Index++] = NewTokens[i];
}

// =================================================================================== 

void
TConfigHandler::SetConfig(TConfig *theConfig)

{
    Config = theConfig;
}

// =================================================================================== 

void
TConfigHandler::SignatureHeader(const char *header) const

{
    if (Config)
        Config->SignatureHeader(header);
}

// =================================================================================== 

void
TConfigHandler::SignatureLine(const char *Format, ...) const

{
    va_list argptr;
    char    line[1024];

    if (Config)
    {
        va_start(argptr, Format);
        vsprintf(line, Format, argptr);
        Config->_SignatureLine(line);
    }
}

// =================================================================================== 
#undef ParentClass
