/*      file     : common/TDebug.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TDebug.C,v 1.6 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***INCLUDES************************************************************************

#include <stdio.h>

#include <Basic.h>
#include <TDebug.h>

// ***DEFINES*************************************************************************

#define MAX_INDENT 63

// ***GLOBAL VARIABLES****************************************************************

TDebug Debug("Program", "Main", "");

char *IndentString = "| | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | "
"| | | | | | | | | | | | | | | | | | | | | | | | | | | | | | | ";

// ***LOCAL VARIABLES*****************************************************************

unsigned long TDebug::Mask = 0;
int           TDebug::Indent = 0;
bool          TDebug::Active = TRUE;

// ***METHODS*************************************************************************

TDebug::TDebug(const char *ClassNamePar, const char *MethodNamePar, 
#ifdef TDEBUG
               const char *InstanceNamePar
#else
               const char *
#endif
)

{
    ClassName = (char *) ClassNamePar;
    MethodName = (char *) MethodNamePar;
#ifdef TDEBUG
    Message("%s::%s(%s) %s", ClassNamePar, MethodNamePar, InstanceNamePar, "START");
#endif
    Indent++;
}

// ===================================================================================

TDebug::~TDebug(void)

{
    Indent--;
#ifdef TDEBUG
    Message("%s::%s %s", ClassName(), MethodName(), "END");
#endif
}

// ===================================================================================

void
TDebug::Activate(void)

{
    Active = TRUE;
}

// ===================================================================================

void
TDebug::AvoidWarning(void)

{
    ;
}

// ===================================================================================

void
TDebug::Deactivate(void)

{
    Active = FALSE;
}

// ===================================================================================

unsigned long
TDebug::GetMask(void)

{
    return Mask;
}

// ===================================================================================

void
TDebug::Message(const char *AFormat ...)

{
    char Line[1024];
    va_list argptr;

    if (Active)
    {
        va_start(argptr, AFormat);
        vsprintf(Line, AFormat, argptr);
        fprintf(stderr, "%s%s\n", IndentString+2*(MAX_INDENT-Indent), Line);
        va_end(argptr);
    }
}    

// ===================================================================================

void
TDebug::SetMask(unsigned long theMask)

{
    Mask = theMask;
}

// ===================================================================================
