/*      file     : common/TID2ContainerEntry.h
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TID2ContainerEntry.h,v 1.7 2005/03/25 11:04:59 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TID2CONTAINERENTRY_H
#define TID2CONTAINERENTRY_H

// ***DEFINES************************************************************************* 

#define SELECT_ID_1 1

// ***INCLUDES************************************************************************ 

#include "TIDContainerEntry.h"

// ***CLASSES************************************************************************* 

/**
  */

class TID2ContainerEntryPrimitive : public TIDContainerEntryPrimitive

{
public:

    TID2ContainerEntryPrimitive(long theID, long theID2, const TBaseObject *theDataPtr);

    virtual int
        Compare(TBaseObject *OtherObject, int CompareCode) const;
    inline long
        GetID2(void) const;

private:

    long ID2;

};

// ===================================================================================

/**
  */

template < class T >
class TID2ContainerEntry : public TID2ContainerEntryPrimitive

{
public:

    TID2ContainerEntry(long theID = INVALID, long theID2 = INVALID, const T *theDataPtr = 0);

    operator T * (void);
};

// ***INLINE METHODS******************************************************************

#ifndef NO_INLINE
#  include "TID2ContainerEntry.i.C"
#endif

// ***TEMPLATE METHODS**************************************************************** 

#if defined (INCLUDE_TEMPLATES) || defined(TEMPLATEBODIES)
#  include "TID2ContainerEntry.t.C"
#endif

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif


