/*      file     : common/TRandom.i.C
        project  : General Toolbox
        author   : Marcus Rickert
        RCS      : $Id: TRandom.i.C,v 1.8 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

// ***METHODS************************************************************************* 

inline double
TRandom::Double(void)

{
    return ((double) Int()) / (double) MaxRand;
}

/* =================================================================================== */

inline long
TRandom::GetMaxRand(void)

{
    return MaxRand;
}

/* =================================================================================== */

inline long
TRandom::Int(void)

{
    if (RndK == 0)
        RndK=MAGIC_COUNT;
    else
        RndK--;
    if (RndJ == 0)
        RndJ=MAGIC_COUNT;
    else
        RndJ--;
    Magic[RndK]=Magic[RndK]+Magic[RndJ];
    return Magic[RndK] & ((1 << 30) - 1);    
}

/* =================================================================================== */

inline long
TRandom::Int(long Max)

{
    return (long) ((double) Int() * (double) Max / (double) MaxRand);
}

/* =================================================================================== */

inline bool
TRandom::IsLower(long Limit)

{
    return Int() < Limit;
}

/* =================================================================================== */

