/*      file     : common/TSignal.h
        project  : General Toolbox
        author   : Marcus Rickert
        objects  : TSignal
                   TSetTimer
        RCS      : $Id: TSignal.h,v 1.6 2005/03/25 11:05:00 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TSIGNAL_H
#define TSIGNAL_H

/* ***INCLUDES************************************************************************ */

#include <stdarg.h>
#include <stdio.h>
#include <sys/time.h>
#include <signal.h>

#include <Basic.h>

#include <TBaseObject.h>

#ifdef SUN4
extern "C" int 
setitimer(int, struct itimerval *, struct itimerval *); /* missing in sys/time.h */
#endif

/* ***DEFINES************************************************************************* */

#define MAX_SIGNAL 64

/* ***TYPES*************************************************************************** */

typedef void (*TSignalHandler) (int);

#ifdef SUN4
TSignalHandler signal(int, TSignalHandler);
#endif

/* ***CLASSES************************************************************************* */

/**
  */

class TSignal : public TBaseObject

{
  protected:

    void              (*OldHandlers[MAX_SIGNAL])();
    bool              SignalActive[MAX_SIGNAL];
#ifndef NO_SIGNAL
    struct sigaction  OldActions[MAX_SIGNAL];
#endif
    
  public:

    TSignal(void);
    virtual ~TSignal(void);

    bool
        CatchSignal(int SignalNr);
    virtual void
        HandleErrorString(const char *String);
    virtual int
        HandleSignal(int SignalNr);
    void
        RestoreAllSignals(void);
    void
        RestoreSignal(int SignalNr);
};

/* ***PROTOTYPES********************************************************************** */
#ifdef __cplusplus
extern "C" {
#endif
    void
        PrintError(const char *String);
    bool
        SetSignalObject(TSignal *anObject);
    void
        MySignalHandler(int SignalNr, ...);
#ifdef __cplusplus
}
#endif
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
