/*      file     : graphx/grFntArr.c
        project  : graphical toolbox
        author   : Michael Olesen
        comments : simple classes for using X11
        RCS      : $Id: grFntArr.c,v 1.2 2005/03/25 11:06:10 mr Exp $
*/

#include <graphx.h>

char grFontFamilies[5][30] = {"Courier","Helvetica","New Century Schoolbook",
  "Times","Symbol"};
char grFontWeights[2][30] = {"Medium","Bold"};
char grFontShapes[2][30] = {"Regular","Italic"};
char grFontNames[697][100] = {
  GR_FNT_CMR0,GR_FNT_CMR1,GR_FNT_CMR2,GR_FNT_CMR3,GR_FNT_CMR4,
  GR_FNT_CMR5,GR_FNT_CMR6,GR_FNT_CMR7,GR_FNT_CMR8,GR_FNT_CMR9,
  GR_FNT_CMR10,GR_FNT_CMR11,GR_FNT_CMR12,GR_FNT_CMR13,GR_FNT_CMR14,
  GR_FNT_CMR15,GR_FNT_CMR16,GR_FNT_CMR17,GR_FNT_CMR18,GR_FNT_CMR19,
  GR_FNT_CMR20,GR_FNT_CMR21,GR_FNT_CMR22,GR_FNT_CMR23,GR_FNT_CMR24,
  GR_FNT_CMR25,GR_FNT_CMR26,GR_FNT_CMR27,GR_FNT_CMR28,GR_FNT_CMR29,
  GR_FNT_CMR30,GR_FNT_CMR31,GR_FNT_CMR32,GR_FNT_CMR33,GR_FNT_CMR34,
  GR_FNT_CMR35,GR_FNT_CMR36,GR_FNT_CMR37,GR_FNT_CMR38,GR_FNT_CMR39,
  GR_FNT_CMR40,
  GR_FNT_CMI0,GR_FNT_CMI1,GR_FNT_CMI2,GR_FNT_CMI3,GR_FNT_CMI4,
  GR_FNT_CMI5,GR_FNT_CMI6,GR_FNT_CMI7,GR_FNT_CMI8,GR_FNT_CMI9,
  GR_FNT_CMI10,GR_FNT_CMI11,GR_FNT_CMI12,GR_FNT_CMI13,GR_FNT_CMI14,
  GR_FNT_CMI15,GR_FNT_CMI16,GR_FNT_CMI17,GR_FNT_CMI18,GR_FNT_CMI19,
  GR_FNT_CMI20,GR_FNT_CMI21,GR_FNT_CMI22,GR_FNT_CMI23,GR_FNT_CMI24,
  GR_FNT_CMI25,GR_FNT_CMI26,GR_FNT_CMI27,GR_FNT_CMI28,GR_FNT_CMI29,
  GR_FNT_CMI30,GR_FNT_CMI31,GR_FNT_CMI32,GR_FNT_CMI33,GR_FNT_CMI34,
  GR_FNT_CMI35,GR_FNT_CMI36,GR_FNT_CMI37,GR_FNT_CMI38,GR_FNT_CMI39,
  GR_FNT_CMI40,
  GR_FNT_CBR0,GR_FNT_CBR1,GR_FNT_CBR2,GR_FNT_CBR3,GR_FNT_CBR4,
  GR_FNT_CBR5,GR_FNT_CBR6,GR_FNT_CBR7,GR_FNT_CBR8,GR_FNT_CBR9,
  GR_FNT_CBR10,GR_FNT_CBR11,GR_FNT_CBR12,GR_FNT_CBR13,GR_FNT_CBR14,
  GR_FNT_CBR15,GR_FNT_CBR16,GR_FNT_CBR17,GR_FNT_CBR18,GR_FNT_CBR19,
  GR_FNT_CBR20,GR_FNT_CBR21,GR_FNT_CBR22,GR_FNT_CBR23,GR_FNT_CBR24,
  GR_FNT_CBR25,GR_FNT_CBR26,GR_FNT_CBR27,GR_FNT_CBR28,GR_FNT_CBR29,
  GR_FNT_CBR30,GR_FNT_CBR31,GR_FNT_CBR32,GR_FNT_CBR33,GR_FNT_CBR34,
  GR_FNT_CBR35,GR_FNT_CBR36,GR_FNT_CBR37,GR_FNT_CBR38,GR_FNT_CBR39,
  GR_FNT_CBR40,
  GR_FNT_CBI0,GR_FNT_CBI1,GR_FNT_CBI2,GR_FNT_CBI3,GR_FNT_CBI4,
  GR_FNT_CBI5,GR_FNT_CBI6,GR_FNT_CBI7,GR_FNT_CBI8,GR_FNT_CBI9,
  GR_FNT_CBI10,GR_FNT_CBI11,GR_FNT_CBI12,GR_FNT_CBI13,GR_FNT_CBI14,
  GR_FNT_CBI15,GR_FNT_CBI16,GR_FNT_CBI17,GR_FNT_CBI18,GR_FNT_CBI19,
  GR_FNT_CBI20,GR_FNT_CBI21,GR_FNT_CBI22,GR_FNT_CBI23,GR_FNT_CBI24,
  GR_FNT_CBI25,GR_FNT_CBI26,GR_FNT_CBI27,GR_FNT_CBI28,GR_FNT_CBI29,
  GR_FNT_CBI30,GR_FNT_CBI31,GR_FNT_CBI32,GR_FNT_CBI33,GR_FNT_CBI34,
  GR_FNT_CBI35,GR_FNT_CBI36,GR_FNT_CBI37,GR_FNT_CBI38,GR_FNT_CBI39,
  GR_FNT_CBI40,
  GR_FNT_HMR0,GR_FNT_HMR1,GR_FNT_HMR2,GR_FNT_HMR3,GR_FNT_HMR4,
  GR_FNT_HMR5,GR_FNT_HMR6,GR_FNT_HMR7,GR_FNT_HMR8,GR_FNT_HMR9,
  GR_FNT_HMR10,GR_FNT_HMR11,GR_FNT_HMR12,GR_FNT_HMR13,GR_FNT_HMR14,
  GR_FNT_HMR15,GR_FNT_HMR16,GR_FNT_HMR17,GR_FNT_HMR18,GR_FNT_HMR19,
  GR_FNT_HMR20,GR_FNT_HMR21,GR_FNT_HMR22,GR_FNT_HMR23,GR_FNT_HMR24,
  GR_FNT_HMR25,GR_FNT_HMR26,GR_FNT_HMR27,GR_FNT_HMR28,GR_FNT_HMR29,
  GR_FNT_HMR30,GR_FNT_HMR31,GR_FNT_HMR32,GR_FNT_HMR33,GR_FNT_HMR34,
  GR_FNT_HMR35,GR_FNT_HMR36,GR_FNT_HMR37,GR_FNT_HMR38,GR_FNT_HMR39,
  GR_FNT_HMR40,
  GR_FNT_HMI0,GR_FNT_HMI1,GR_FNT_HMI2,GR_FNT_HMI3,GR_FNT_HMI4,
  GR_FNT_HMI5,GR_FNT_HMI6,GR_FNT_HMI7,GR_FNT_HMI8,GR_FNT_HMI9,
  GR_FNT_HMI10,GR_FNT_HMI11,GR_FNT_HMI12,GR_FNT_HMI13,GR_FNT_HMI14,
  GR_FNT_HMI15,GR_FNT_HMI16,GR_FNT_HMI17,GR_FNT_HMI18,GR_FNT_HMI19,
  GR_FNT_HMI20,GR_FNT_HMI21,GR_FNT_HMI22,GR_FNT_HMI23,GR_FNT_HMI24,
  GR_FNT_HMI25,GR_FNT_HMI26,GR_FNT_HMI27,GR_FNT_HMI28,GR_FNT_HMI29,
  GR_FNT_HMI30,GR_FNT_HMI31,GR_FNT_HMI32,GR_FNT_HMI33,GR_FNT_HMI34,
  GR_FNT_HMI35,GR_FNT_HMI36,GR_FNT_HMI37,GR_FNT_HMI38,GR_FNT_HMI39,
  GR_FNT_HMI40,
  GR_FNT_HBR0,GR_FNT_HBR1,GR_FNT_HBR2,GR_FNT_HBR3,GR_FNT_HBR4,
  GR_FNT_HBR5,GR_FNT_HBR6,GR_FNT_HBR7,GR_FNT_HBR8,GR_FNT_HBR9,
  GR_FNT_HBR10,GR_FNT_HBR11,GR_FNT_HBR12,GR_FNT_HBR13,GR_FNT_HBR14,
  GR_FNT_HBR15,GR_FNT_HBR16,GR_FNT_HBR17,GR_FNT_HBR18,GR_FNT_HBR19,
  GR_FNT_HBR20,GR_FNT_HBR21,GR_FNT_HBR22,GR_FNT_HBR23,GR_FNT_HBR24,
  GR_FNT_HBR25,GR_FNT_HBR26,GR_FNT_HBR27,GR_FNT_HBR28,GR_FNT_HBR29,
  GR_FNT_HBR30,GR_FNT_HBR31,GR_FNT_HBR32,GR_FNT_HBR33,GR_FNT_HBR34,
  GR_FNT_HBR35,GR_FNT_HBR36,GR_FNT_HBR37,GR_FNT_HBR38,GR_FNT_HBR39,
  GR_FNT_HBR40,
  GR_FNT_HBI0,GR_FNT_HBI1,GR_FNT_HBI2,GR_FNT_HBI3,GR_FNT_HBI4,
  GR_FNT_HBI5,GR_FNT_HBI6,GR_FNT_HBI7,GR_FNT_HBI8,GR_FNT_HBI9,
  GR_FNT_HBI10,GR_FNT_HBI11,GR_FNT_HBI12,GR_FNT_HBI13,GR_FNT_HBI14,
  GR_FNT_HBI15,GR_FNT_HBI16,GR_FNT_HBI17,GR_FNT_HBI18,GR_FNT_HBI19,
  GR_FNT_HBI20,GR_FNT_HBI21,GR_FNT_HBI22,GR_FNT_HBI23,GR_FNT_HBI24,
  GR_FNT_HBI25,GR_FNT_HBI26,GR_FNT_HBI27,GR_FNT_HBI28,GR_FNT_HBI29,
  GR_FNT_HBI30,GR_FNT_HBI31,GR_FNT_HBI32,GR_FNT_HBI33,GR_FNT_HBI34,
  GR_FNT_HBI35,GR_FNT_HBI36,GR_FNT_HBI37,GR_FNT_HBI38,GR_FNT_HBI39,
  GR_FNT_HBI40,
  GR_FNT_NCMR0,GR_FNT_NCMR1,GR_FNT_NCMR2,GR_FNT_NCMR3,GR_FNT_NCMR4,
  GR_FNT_NCMR5,GR_FNT_NCMR6,GR_FNT_NCMR7,GR_FNT_NCMR8,GR_FNT_NCMR9,
  GR_FNT_NCMR10,GR_FNT_NCMR11,GR_FNT_NCMR12,GR_FNT_NCMR13,GR_FNT_NCMR14,
  GR_FNT_NCMR15,GR_FNT_NCMR16,GR_FNT_NCMR17,GR_FNT_NCMR18,GR_FNT_NCMR19,
  GR_FNT_NCMR20,GR_FNT_NCMR21,GR_FNT_NCMR22,GR_FNT_NCMR23,GR_FNT_NCMR24,
  GR_FNT_NCMR25,GR_FNT_NCMR26,GR_FNT_NCMR27,GR_FNT_NCMR28,GR_FNT_NCMR29,
  GR_FNT_NCMR30,GR_FNT_NCMR31,GR_FNT_NCMR32,GR_FNT_NCMR33,GR_FNT_NCMR34,
  GR_FNT_NCMR35,GR_FNT_NCMR36,GR_FNT_NCMR37,GR_FNT_NCMR38,GR_FNT_NCMR39,
  GR_FNT_NCMR40,
  GR_FNT_NCMI0,GR_FNT_NCMI1,GR_FNT_NCMI2,GR_FNT_NCMI3,GR_FNT_NCMI4,
  GR_FNT_NCMI5,GR_FNT_NCMI6,GR_FNT_NCMI7,GR_FNT_NCMI8,GR_FNT_NCMI9,
  GR_FNT_NCMI10,GR_FNT_NCMI11,GR_FNT_NCMI12,GR_FNT_NCMI13,GR_FNT_NCMI14,
  GR_FNT_NCMI15,GR_FNT_NCMI16,GR_FNT_NCMI17,GR_FNT_NCMI18,GR_FNT_NCMI19,
  GR_FNT_NCMI20,GR_FNT_NCMI21,GR_FNT_NCMI22,GR_FNT_NCMI23,GR_FNT_NCMI24,
  GR_FNT_NCMI25,GR_FNT_NCMI26,GR_FNT_NCMI27,GR_FNT_NCMI28,GR_FNT_NCMI29,
  GR_FNT_NCMI30,GR_FNT_NCMI31,GR_FNT_NCMI32,GR_FNT_NCMI33,GR_FNT_NCMI34,
  GR_FNT_NCMI35,GR_FNT_NCMI36,GR_FNT_NCMI37,GR_FNT_NCMI38,GR_FNT_NCMI39,
  GR_FNT_NCMI40,
  GR_FNT_NCBR0,GR_FNT_NCBR1,GR_FNT_NCBR2,GR_FNT_NCBR3,GR_FNT_NCBR4,
  GR_FNT_NCBR5,GR_FNT_NCBR6,GR_FNT_NCBR7,GR_FNT_NCBR8,GR_FNT_NCBR9,
  GR_FNT_NCBR10,GR_FNT_NCBR11,GR_FNT_NCBR12,GR_FNT_NCBR13,GR_FNT_NCBR14,
  GR_FNT_NCBR15,GR_FNT_NCBR16,GR_FNT_NCBR17,GR_FNT_NCBR18,GR_FNT_NCBR19,
  GR_FNT_NCBR20,GR_FNT_NCBR21,GR_FNT_NCBR22,GR_FNT_NCBR23,GR_FNT_NCBR24,
  GR_FNT_NCBR25,GR_FNT_NCBR26,GR_FNT_NCBR27,GR_FNT_NCBR28,GR_FNT_NCBR29,
  GR_FNT_NCBR30,GR_FNT_NCBR31,GR_FNT_NCBR32,GR_FNT_NCBR33,GR_FNT_NCBR34,
  GR_FNT_NCBR35,GR_FNT_NCBR36,GR_FNT_NCBR37,GR_FNT_NCBR38,GR_FNT_NCBR39,
  GR_FNT_NCBR40,
  GR_FNT_NCBI0,GR_FNT_NCBI1,GR_FNT_NCBI2,GR_FNT_NCBI3,GR_FNT_NCBI4,
  GR_FNT_NCBI5,GR_FNT_NCBI6,GR_FNT_NCBI7,GR_FNT_NCBI8,GR_FNT_NCBI9,
  GR_FNT_NCBI10,GR_FNT_NCBI11,GR_FNT_NCBI12,GR_FNT_NCBI13,GR_FNT_NCBI14,
  GR_FNT_NCBI15,GR_FNT_NCBI16,GR_FNT_NCBI17,GR_FNT_NCBI18,GR_FNT_NCBI19,
  GR_FNT_NCBI20,GR_FNT_NCBI21,GR_FNT_NCBI22,GR_FNT_NCBI23,GR_FNT_NCBI24,
  GR_FNT_NCBI25,GR_FNT_NCBI26,GR_FNT_NCBI27,GR_FNT_NCBI28,GR_FNT_NCBI29,
  GR_FNT_NCBI30,GR_FNT_NCBI31,GR_FNT_NCBI32,GR_FNT_NCBI33,GR_FNT_NCBI34,
  GR_FNT_NCBI35,GR_FNT_NCBI36,GR_FNT_NCBI37,GR_FNT_NCBI38,GR_FNT_NCBI39,
  GR_FNT_NCBI40,
  
  GR_FNT_TMR0,GR_FNT_TMR1,GR_FNT_TMR2,GR_FNT_TMR3,GR_FNT_TMR4,
  GR_FNT_TMR5,GR_FNT_TMR6,GR_FNT_TMR7,GR_FNT_TMR8,GR_FNT_TMR9,
  GR_FNT_TMR10,GR_FNT_TMR11,GR_FNT_TMR12,GR_FNT_TMR13,GR_FNT_TMR14,
  GR_FNT_TMR15,GR_FNT_TMR16,GR_FNT_TMR17,GR_FNT_TMR18,GR_FNT_TMR19,
  GR_FNT_TMR20,GR_FNT_TMR21,GR_FNT_TMR22,GR_FNT_TMR23,GR_FNT_TMR24,
  GR_FNT_TMR25,GR_FNT_TMR26,GR_FNT_TMR27,GR_FNT_TMR28,GR_FNT_TMR29,
  GR_FNT_TMR30,GR_FNT_TMR31,GR_FNT_TMR32,GR_FNT_TMR33,GR_FNT_TMR34,
  GR_FNT_TMR35,GR_FNT_TMR36,GR_FNT_TMR37,GR_FNT_TMR38,GR_FNT_TMR39,
  GR_FNT_TMR40,
  GR_FNT_TMI0,GR_FNT_TMI1,GR_FNT_TMI2,GR_FNT_TMI3,GR_FNT_TMI4,
  GR_FNT_TMI5,GR_FNT_TMI6,GR_FNT_TMI7,GR_FNT_TMI8,GR_FNT_TMI9,
  GR_FNT_TMI10,GR_FNT_TMI11,GR_FNT_TMI12,GR_FNT_TMI13,GR_FNT_TMI14,
  GR_FNT_TMI15,GR_FNT_TMI16,GR_FNT_TMI17,GR_FNT_TMI18,GR_FNT_TMI19,
  GR_FNT_TMI20,GR_FNT_TMI21,GR_FNT_TMI22,GR_FNT_TMI23,GR_FNT_TMI24,
  GR_FNT_TMI25,GR_FNT_TMI26,GR_FNT_TMI27,GR_FNT_TMI28,GR_FNT_TMI29,
  GR_FNT_TMI30,GR_FNT_TMI31,GR_FNT_TMI32,GR_FNT_TMI33,GR_FNT_TMI34,
  GR_FNT_TMI35,GR_FNT_TMI36,GR_FNT_TMI37,GR_FNT_TMI38,GR_FNT_TMI39,
  GR_FNT_TMI40,
  GR_FNT_TBR0,GR_FNT_TBR1,GR_FNT_TBR2,GR_FNT_TBR3,GR_FNT_TBR4,
  GR_FNT_TBR5,GR_FNT_TBR6,GR_FNT_TBR7,GR_FNT_TBR8,GR_FNT_TBR9,
  GR_FNT_TBR10,GR_FNT_TBR11,GR_FNT_TBR12,GR_FNT_TBR13,GR_FNT_TBR14,
  GR_FNT_TBR15,GR_FNT_TBR16,GR_FNT_TBR17,GR_FNT_TBR18,GR_FNT_TBR19,
  GR_FNT_TBR20,GR_FNT_TBR21,GR_FNT_TBR22,GR_FNT_TBR23,GR_FNT_TBR24,
  GR_FNT_TBR25,GR_FNT_TBR26,GR_FNT_TBR27,GR_FNT_TBR28,GR_FNT_TBR29,
  GR_FNT_TBR30,GR_FNT_TBR31,GR_FNT_TBR32,GR_FNT_TBR33,GR_FNT_TBR34,
  GR_FNT_TBR35,GR_FNT_TBR36,GR_FNT_TBR37,GR_FNT_TBR38,GR_FNT_TBR39,
  GR_FNT_TBR40,
  GR_FNT_TBI0,GR_FNT_TBI1,GR_FNT_TBI2,GR_FNT_TBI3,GR_FNT_TBI4,
  GR_FNT_TBI5,GR_FNT_TBI6,GR_FNT_TBI7,GR_FNT_TBI8,GR_FNT_TBI9,
  GR_FNT_TBI10,GR_FNT_TBI11,GR_FNT_TBI12,GR_FNT_TBI13,GR_FNT_TBI14,
  GR_FNT_TBI15,GR_FNT_TBI16,GR_FNT_TBI17,GR_FNT_TBI18,GR_FNT_TBI19,
  GR_FNT_TBI20,GR_FNT_TBI21,GR_FNT_TBI22,GR_FNT_TBI23,GR_FNT_TBI24,
  GR_FNT_TBI25,GR_FNT_TBI26,GR_FNT_TBI27,GR_FNT_TBI28,GR_FNT_TBI29,
  GR_FNT_TBI30,GR_FNT_TBI31,GR_FNT_TBI32,GR_FNT_TBI33,GR_FNT_TBI34,
  GR_FNT_TBI35,GR_FNT_TBI36,GR_FNT_TBI37,GR_FNT_TBI38,GR_FNT_TBI39,
  GR_FNT_TBI40,
  GR_FNT_SMR0,GR_FNT_SMR1,GR_FNT_SMR2,GR_FNT_SMR3,GR_FNT_SMR4,
  GR_FNT_SMR5,GR_FNT_SMR6,GR_FNT_SMR7,GR_FNT_SMR8,GR_FNT_SMR9,
  GR_FNT_SMR10,GR_FNT_SMR11,GR_FNT_SMR12,GR_FNT_SMR13,GR_FNT_SMR14,
  GR_FNT_SMR15,GR_FNT_SMR16,GR_FNT_SMR17,GR_FNT_SMR18,GR_FNT_SMR19,
  GR_FNT_SMR20,GR_FNT_SMR21,GR_FNT_SMR22,GR_FNT_SMR23,GR_FNT_SMR24,
  GR_FNT_SMR25,GR_FNT_SMR26,GR_FNT_SMR27,GR_FNT_SMR28,GR_FNT_SMR29,
  GR_FNT_SMR30,GR_FNT_SMR31,GR_FNT_SMR32,GR_FNT_SMR33,GR_FNT_SMR34,
  GR_FNT_SMR35,GR_FNT_SMR36,GR_FNT_SMR37,GR_FNT_SMR38,GR_FNT_SMR39,
  GR_FNT_SMR40};
