/*      file     : mpi/TMPIParallelControl.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TMPIParallelControl.h,v 1.7 2005/05/01 14:57:58 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TMPIPARALLELCONTROL_H
#define TMPIPARALLELCONTROL_H

// ***INCLUDES************************************************************************ 

#include <TDLList.h>
#include <ParallelTypes.h>
#include <TParallelControl.h>

// ***FORWARDS************************************************************************

class TCPNInfo;
class THostInfo;

// ***TYPES*************************************************************************** 

struct TMpiMutable

{
};

// ***CLASSES************************************************************************* 

class TMPIParallelControl : public TParallelControl

{
public:

    TMPIParallelControl(int *pargc, char **pargv[]);
    virtual ~TMPIParallelControl(void);

protected:

    virtual bool
        Activate(void);
    virtual bool
        Disenroll(void);
    virtual bool
        Enroll(void);
    virtual bool
        IsMaster(void) const;

private:

    bool
        CheckCPNInfoList(void) const;
    bool
        CheckHostInfoList(void) const;
    virtual TString
        GetClassName(void) const;
    virtual int
        GetMaxNrOfCPN(void) const;
    virtual TCPNID
        GetParentCPNID(void) const;
    void
        _Init(void);

    TCPNID         LocalCPNID;
    TCPNID         ParentCPNID;

    TMpiMutable   *MpiMutable;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
