divert(-1)
/*      file     : mpi/template/MPIDecodeEncode.Body.m4
	project  : Parallel Toolbox 2.x
	author   : Marcus Rickert
	RCS      : $Id: MPIDecodeEncode.Body.m4,v 1.9 1998/04/30 17:11:14 mr Exp $
*/

// ***FUNCTIONS*********************************************************************** 

divert(0)
bool
#ifdef MSG_CHECK
CLASS::Decode(TYPE &Data, long Count, long Stride)
#else
CLASS::Decode(TYPE &Data, long Count, long)
#endif

{
#ifdef MSG_CHECK
    if (Stride != 1)
    {
	Error("Stride != 1 not supported");
	return FALSE;
    }
    int RequiredSize = 0;
    MPI_Pack_size(Count, MPITYPE, MPI_COMM_WORLD, &RequiredSize);
    if (!Buffer->Check(RequiredSize))
    {
	Error("Decode: buffer overflow");
	return FALSE;
    }
#endif
    MPI_Unpack(Buffer->GetBase(), (int) Buffer->GetSize(), &Buffer->GetPosition(), 
	       (void *) &Data, (int) Count, MPITYPE, MPI_COMM_WORLD);
    IfDebug(DM_CODE, Print("Decode: TYPE * %ld", Count));
    return TRUE;
}

// ===================================================================================

divert(0)
bool
#ifdef MSG_CHECK
CLASS::Encode(const TYPE &Data, long Count, long Stride) const
#else
CLASS::Encode(const TYPE &Data, long Count, long) const
#endif

{
#ifdef MSG_CHECK
    if (Stride != 1)
    {
	Error("Stride != 1 not supported");
	return FALSE;
    }
    int RequiredSize = 0;
    MPI_Pack_size(Count, MPITYPE, MPI_COMM_WORLD, &RequiredSize);
    if (!Buffer->Check(RequiredSize))
    {
	Error("Encode: buffer overflow");
	return FALSE;
    }
#endif
    MPI_Pack((void *) &Data, (int) Count, MPITYPE, Buffer->GetBase(), 
	     (int) Buffer->GetSize(), &Buffer->GetPosition(), MPI_COMM_WORLD);
    IfDebug(DM_CODE, Print("Encode: TYPE * %ld", Count));
    return TRUE;
}

// ===================================================================================
divert(-1)
// Local Variables:
// mode:c++
// End:


