/*      file     : parbalance/TLocalBalancer.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TLocalBalancer.h,v 1.4 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TLOCALBALANCER_H
#define TLOCALBALANCER_H

// ***INCLUDES************************************************************************ 

#include <TBaseBalancer.h>
#include <TStatHandler.h>

// ***CLASSES************************************************************************* 

class TLocalBalancer : public TBaseBalancer, public TStatHandler

{
public:

    TLocalBalancer(void);
    virtual ~TLocalBalancer(void);

private:

    virtual bool
    ExecuteSubTimeStep(TTimeStep &TimeStep);

    virtual TString
    GetClassName(void) const;

    virtual bool
    HandleAggregationResult(TAggregationInfo *AggregationInfo, TTimeStep &TimeStep);

    bool
    HandleLoadResult(TAggregationInfo *AggregationInfo, TTimeStep &TimeStep);

    virtual bool
    Run(void);
    
    bool
    SelectTransfer(TTimeStep &TimeStep, TLoadStat *MyStat, TLoadStat *MinStat);

    TAggregationInfo     *LoadAggregationInfo;
    TSamplingDescription *LoadSamplingDescription;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
