/*      file     : partools/TNeighborCommInfo.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TNeighborCommInfo.h,v 1.2 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TNEIGHBORCOMMINFO_H
#define TNEIGHBORCOMMINFO_H

// ***INCLUDES************************************************************************ 

#include <TDLList.h>
#include <TStatObject.h>

// ***FORWARDS************************************************************************

class TExtendedCPNInfo;

// ***CLASSES************************************************************************* 

class TNeighborCommInfo : public TStatObject

{
public:
    
    TNeighborCommInfo(TParallelID theParallelID);
    virtual ~TNeighborCommInfo(void);

    bool
    Collect(TExtendedCPNInfo *Info);

    static TClassInfo *ClassInfo;

    long   NrOfBoundaries;
    double TransferLoad;

private:

    virtual bool
    Decode(TBaseStream *aStream, TTransferInfo *TransferInfo);

    virtual bool
    Encode(TBaseStream *aStream, TTransferInfo *TransferInfo) const;

    virtual TString
    GetClassName(void) const;

    virtual void
    Reset(void);                      
};

// ***TYPES*************************************************************************** 

typedef TDLList < TNeighborCommInfo > TNeighborCommInfoList;
typedef TDLListEnum < TNeighborCommInfo > TNeighborCommInfoEnum;

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
