/*      file     : parbalance/TStaticBalancer.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TStaticBalancer.h,v 1.5 2005/03/25 11:06:49 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TSTATICBALANCER_H
#define TSTATICBALANCER_H

// ***INCLUDES************************************************************************ 

#include <TBaseObject.h>

#include <ParallelTypes.h>
#include <ParToolsTypes.h>

#include <TNode.h>
#include <TEdge.h>

// ***FORWARDS************************************************************************

class TTopology;

// ***CLASSES************************************************************************* 

class TStaticBalancer : public TBaseObject

{
public:

    TStaticBalancer(TNodeList *theNodes, TInfoID theLocationInfoID,
                    TEdgeList *theEdges, TInfoID theAdjacenceInfoID,
                    TTopology *theTopology,
                    bool LocalDistributionFlag);
    virtual ~TStaticBalancer(void);

    TEdgeList *
    GetEdgesOnCPN(int CPNIndex);

    TNodeList *
    GetNodesOnCPN(int CPNIndex);

    bool
    OrthogonalBisection(void);

private:

    TNodeList *Nodes;
    TEdgeList *Edges;
    TTopology *Topology;
    TInfoID    LocationInfoID;
    TInfoID    AdjacenceInfoID;
    bool       LocalDistribution;
    bool       BisectionStat;
    TNodeList *NodeLists;
    TEdgeList *EdgeLists;
};

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
