/*      file     : partools/ParToolsTypes.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: ParToolsTypes.h,v 1.10 2005/05/01 14:57:58 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef PARTOOLSTYPES_H
#define PARTOOLSTYPES_H

// ***INCLUDES************************************************************************ 

#include <CommonTypes.h>

#include <ParallelTypes.h>

// ***DEFINES************************************************************************* 

#define CLASS_NODE               "Node"
#define CLASS_EDGE               "Edge"
#define CLASS_EXTENDED_CPNINFO   "ExtendedCPNInfo"
#define CLASS_COMMUNICATION_LINK "CommunicationLink"
#define CLASS_LOCATION           "@Location"
#define CLASS_ADJACENCE          "@Adjacence"
#define CLASS_INCIDENCE          "@Incidence"

#define MAX_CONTAINER_DEPS    64

#define MTAG_OBJ_MGR          (MTAG_BASE)        // 0x004
#define MTAG_APP_SLAVE        ((MTAG_BASE) << 1) // 0x008
#define MTAG_APP_MASTER       ((MTAG_BASE) << 2) // 0x010
#define MTAG_STAT_MGR         ((MTAG_BASE) << 3) // 0x020
#define MTAG_MIGRATION        ((MTAG_BASE) << 4) // 0x040
#define MTAG_BOUNDARIES       ((MTAG_BASE) << 5) // 0x080
#define MTAG_LOAD_BALANCER    ((MTAG_BASE) << 6) // 0x100
#define MTAG_ROUTER           ((MTAG_BASE) << 7) // 0x200
#define MTAG_FIRST_FREE_TAG   ((MTAG_BASE) << 8) // 0x400

#define MTYPE_OBJ_MGR                 (MTYPE_BASE)
#define MTYPE_OBJ_MGR_MIGRATION       (MTYPE_BASE + 1)
#define MTYPE_OBJ_MGR_MIGRATION_INFOS (MTYPE_BASE + 2)
#define MTYPE_APP_SLAVE               (MTYPE_BASE)
#define MTYPE_APP_MASTER              (MTYPE_BASE)
#define MTYPE_STAT_MGR                (MTYPE_BASE)
#define MTYPE_LOAD_BALANCER           (MTYPE_BASE)
#define MTYPE_ROUTER                  (MTYPE_BASE)

#define MEVENT_OBJ_MGR_TRANSFER_CONTAINER      1
#define MEVENT_OBJ_MGR_TRANSFER_COMPLETE       2
#define MEVENT_OBJ_MGR_BOUNDARIES              3
#define MEVENT_OBJ_MGR_MIGRATION_INFO          4
#define MEVENT_OBJ_MGR_MONITOR_MIGRATION_INFO  5

// ***TYPES*************************************************************************** 

typedef LongID TParallelID;
typedef short int TInfoID;
typedef short int TClassID;
typedef LongID TInfoMask;

#define PARALLEL_ID_PRINTF_FORMAT LONG_ID_PRINTF_FORMAT
#define SIZE_OF_PARALLEL_ID_IN_LONG SIZE_OF_LONG_ID_IN_LONG

// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
