/*      file     : partools/TNetwork.h
        project  : Parallel Toolbox 2.x
        author   : Marcus Rickert
        RCS      : $Id: TNetwork.h,v 1.3 2005/03/25 11:08:15 mr Exp $

        Copyright (C) 2005 Marcus Rickert

        http://www.the-rickerts.de/mr/PAMINA.html
*/

#ifndef TNETWORK_H
#define TNETWORK_H

// ***INCLUDES************************************************************************ 

#include <TParallelObject.h>

// ***FORWARDS************************************************************************

#include <TExtendedCPNInfo.forward.h>
#include <TCommunicationLink.forward.h>

// ***DEFINES************************************************************************* 
// ***CONSTANTS***********************************************************************
// ***TYPES*************************************************************************** 
// ***CLASSES************************************************************************* 

class TNetwork : public TBaseObject

{
public:
    
    TNetwork(void);
    virtual ~TNetwork(void);

    long
    GetCommunicationLinkID(TCPNID CPNID1, long TCPNID);

    bool
    SplitCommunicationLinkID(long ParallelID, TCPNID &ID1, TCPNID &ID2);

    TCommunicationLink *
    GetCommunicationLink(TParallelID theParallelID, bool Create);

    TCommunicationLink *
    GetCommunicationLink(TCPNID theFromCPNID, TCPNID theToCPNID, bool Create);

    TCommunicationLinkTable *
    GetCommunicationLinkTable(void);

    TExtendedCPNInfo *
    GetExtendedCPNInfo(TCPNID SearchCPNID, bool Create = FALSE);    

private:

};

// ***EXTERNALS*********************************************************************** 

extern TNetwork *Network;

// ***PROTOTYPES********************************************************************** 
#ifdef __cplusplus
extern "C" {
#endif

#ifdef __cplusplus
}
#endif
// ***INLINE METHODS******************************************************************
#ifndef NO_INLINE
#endif
// ***TEMPLATE METHODS**************************************************************** 
// ===================================================================================
// Local Variables:
// mode:c++
// End:
#endif
